;
;   This anti-cup386/7 trick was found when i noticed
;   that the emulation of the Debug Registers in CUP386
;   is simply PERFECT, so perfect that it allows to set
;   certain bits in DR7, that couldn't be set by the
;   processor itself...
;
;
;                                      Lost Soul, 14/11/1996
;                              A COLLECTION OF ANTI CUP386/7 TRICKS
;                                      Released 19/03/1998

;
; > The action is very simply: The code (2001h) enables some bits
; > that aren't used in the processor or are not documented so
; > the emulators just crash when they found it. Such examples:
; > E-PROT halts GTR with a Invalid TSS message. E-PROT crash LTR,
; > and many more. This is the reason.
;
; Meanwhile i think this is not good practice, because there are so many
; different CPU available that behave each other. So why should not emulate a
; CPU this instructions in a other way...
;
;

MODEL TINY
DATASEG
CODESEG
   STARTUPCODE
       START:
      .386p
             mov eax,0FFFF0000h
             xor ecx,ecx
             mov dr7,eax
             mov ebx,dr7
             mov dr7,ecx
             cmp ebx,eax
       self: jz self

             int 20h
END
